--[[--
Das hier sind ein paar Funktionen, die ich mal irgendwo gebraucht hab.
Für mein Orbit-Programm benutze ich garm.copy(), garm.arrow() und garm.kart() (polare --> karthesische Koordinaten).
--]]--
local garm = {}




--[[--
Diese Funktion ist direkt vom Lua-Wiki
table copy_of_mytable = garm.copy(table mytable)
--]]--
garm.copy = function(obj, seen)
  if type(obj) ~= 'table' then return obj end
  if seen and seen[obj] then return seen[obj] end
  local s = seen or {}
  local res = setmetatable({}, getmetatable(obj))
  s[obj] = res
  for k, v in pairs(obj) do res[garm.copy(k, s)] = garm.copy(v, s) end
  return res
end




--[[--
num x, num y = garm.rotateImage(image image, num angle)
Example:
local relx, rely = garm.rotateImage(myImage, math.pi*0.5)
love.graphics.draw(image, totalx + relx, totaly + rely, math.pi*0.5)
--]]--
function garm.rotateImage(image, ang)
  ang = ang - math.pi*0.75 --upper left corner of the image (full revolution: 2*math.pi)
  local midx = image:getWidth()/2 --coordinates of the middle of the image
  local midy = image:getHeight()/2
  local dist = math.sqrt(midx^2 + midy^2) --radius of the circle
  local x = midx + math.cos(ang)*dist
  local y = midy + math.sin(ang)*dist
  return x, y
end




--[[--
num x1, num y1, num x2, num y2, num distance = garm.arrow(num angle, num scale, num middle_angle)
Example:
local x1, y1, x2, y2 = garm.arrow(math.pi/2, 10, 0.5)
love.graphics.line(x1, y1, 0, 0, x2, y2)
--]]--
function garm.arrow(ang, scale, mang)
	scale = scale or 1
	mang = mang or math.pi/3
	mang = mang/2
	local x1 = math.cos(ang + math.pi - mang)*scale
	local x2 = math.cos(ang + math.pi + mang)*scale
	local y1 = math.sin(ang + math.pi - mang)*scale
	local y2 = math.sin(ang + math.pi + mang)*scale
	local dist = math.cos(mang)*scale
	return x1, y1, x2, y2, dist
end




--[[--
num x, num y = garm.kart(num angle, num distance)
--]]--
function garm.kart(ang, dist)
	dist = dist or 1
	local x = math.cos(ang)*dist
	local y = math.sin(ang)*dist
	return x, y
end




return garm