function love.load()
	
	Camera = require("libs.hump.camera")
	Class = require("libs.hump.class") -- objekt-orientiertes Programmieren für Lua
	
	-- meine eigenen Klassen etc.
	garm = require("libs.garm")
	Pixelcam = require("libs.pixelcam")
	require("libs.mathe")
	require("objects.planet")
	require("objects.spaceship")
	
	camspval = 1
	camsp = Pixelcam(camspval)
	
	
	-- graphics initialisation
	love.graphics.setNewFont("resources/cour.ttf", 16)
	love.graphics.setBackgroundColor(255,255,255)
	-- canvas für die Spuren
	local canvasSize = love.graphics.getSystemLimit("texturesize")
	canvas = love.graphics.newCanvas(canvasSize, canvasSize)
-- 	canvas = love.graphics.newCanvas(800, 800) -- uncomment for reduced lag
	
	
	-- camera initialisation
	cam = Camera(0, 0)
	cam.moving = false -- camera moving with cursor
	
	
	-- variables/settings initialisation
	steptime = 2 -- the time one step is long (affects the result)
	frtime = 0.01 -- the time the program will wait between calculating steps (doesn't affect the result) (nil = doesn't wait at all)
	shipacceleration = 0.001 -- acceleration when accelerating with a spaceship
	debugdisplay = true -- press D to toggle
	helpdisplay = true -- press H to toggle
 	trails = true -- press F to toggle
--	trails = false -- press F to toggle
	controlled = true -- press C to toggle
	planetsegments = 100 -- set lower for smoother framerate
	
	
	spawning = {bool = false}
	rectime = 0
	entities = {}
	currentscenario = 0
	scenarios = {}
	
	-- Wie man einen Planeten erzeugt (fixed ist ein Boolean): Planet(Masse, fixed, x-Pos, y-Pos, x-Geschw, y-Geschw, r, g, b)
	-- Wie man ein Raumschiff erzeigt (controllable ist ein Boolean): Spaceship(Masse, controllable, x-Pos, y-Pos, x-Geschw, y-Geschw, r, g, b)
	-- scenarios (einfach weitere anhängen wenn die hier nicht genug sind)
	-- Diese hier sind nicht unbedingt gute Beispiele.
	scenarios[0] = { -- Mond kreist um fixen Planeten
		Planet(60, true, 0, 0, 0, 0, 255, 0, 0),
		Planet(10, false, 200, 0, 0, 0.5, 255, 255, 0),
	}
	scenarios[1] = { -- Das eine Raumschiff ist steuerbar (Pfeiltasten)
		Planet(50, true, 0, 0, 0, 0, 255, 127, 0),
		Spaceship(0, true, 200, 0, 0, 0.5, 255, 127, 0),
		Spaceship(0, false, -200, 0, 0, -0.5, 0, 255, 255),
	}
	scenarios[2] = { -- "Mond"-"Erde"-Szenario mit volkommen unrealistischen Massen/Entfernungen etc.
		Planet(50, false, 0, 0, 0, -0.45/5, 255, 0, 0),
		Planet(10, false, 200, 0, 0, 0.45, 255, 255, 0),
	}
	scenarios[3] = { -- Erde-Mond-Szenario NICHT REALISTISCH
		Planet(81, false, 0, 0, 0, -0.45/81, 0, 0, 127), -- "Erde"
		Planet(1, false, 384, 0, 0, 0.45, 127, 127, 127), -- "Mond"
		Spaceship(0, false, -384, 0, 0, -0.45, 255, 0, 0), -- Raumschiff gegenüber Mond - hat andere Umlaufbahn, da es von Erde UND Mond angezogen wird
		Spaceship(0, false, 0, -80, 1, 0, 0, 255, 255), -- Auf kreisförmiger Umlaufbahn um "Erde"
		Spaceship(0, false, 0, -80, 1.2865, 0, 127, 255, 0), -- lunar swing-by (glaube ich)
		Spaceship(0, false, 0, -80, 1.31, 0, 255, 127, 0), -- etwas höhere Umlaufbahn
	}
	scenarios[4] = { -- ruhende Erde, gleiche Umlaufbahnen wie in Szenario 3, nur one den Mond
		Planet(81, true, 0, 0, 0, 0, 0, 0, 127), -- "Erde"
		Spaceship(0, false, -384, 0, 0, -0.45, 255, 0, 0), -- Raumschiff gegenüber Mond - hat andere Umlaufbahn, da es von Erde UND Mond angezogen wird
		Spaceship(0, false, 0, -80, 1, 0, 0, 255, 255), -- Auf kreisförmiger Umlaufbahn um "Erde"
		Spaceship(0, false, 0, -80, 1.2865, 0, 127, 255, 0), -- lunar swing-by (glaube ich)
		Spaceship(0, false, 0, -80, 1.31, 0, 255, 127, 0), -- etwas höhere Umlaufbahn
	}
	scenarios[5] = {
		Planet(50, true, 0, 0, 0, 0, 255, 0, 0),
		Planet(1, false, 200, 0, 0, 0.3, 255, 255, 0),
		Planet(1, false, -200, 0, 0, -0.3, 0, 255, 255),
	}
	scenarios[6] = {
		Planet(10, false, 100, 0, 0, 0.15, 255, 255, 0),
		Planet(10, false, -100, 0, 0, -0.15, 0, 255, 255),}
	scenarios[7] = {} -- zeigt deutlich, warum/wann meine Berechnungen NICHT der Realität entsprechen.
	for x = -100, 100, 20 do for y = -100, 100, 20 do
		table.insert(scenarios[7], Planet(1, false, x, y, 0, 0, 0, 0, 0))
	end end
	scenarios[8] = {} -- Raumschiffe mit Masse 0 ziehen sich natürlich nicht an
	for x = -100, 100, 20 do for y = -100, 100, 20 do
		table.insert(scenarios[8], Spaceship(0, true, x, y, 0, 0, 0, 0, 0))
	end end
	scenarios[9] = {}
	
	
	
	
	loadScenario(currentscenario)
end

function love.update(dt)
	rectime = rectime + dt
	if frtime then
		if rectime < frtime then
			return
		end
		rectime = rectime%frtime
	end
	
	-- calculate the positions for the planets and spaceships
	for _, entity in pairs(entities) do
		entity:calcPosition()
	end
	
	-- calculate the gravity for the planets and spaceships
	for _, entity in pairs(entities) do
		entity:calcGravity()
	end
end

function love.draw()
	
	if not trails then camsp:startRecording() end ----------------------------------------------------------------
	
	cam:attach()
	
	if trails then -- draw canvas
		love.graphics.setColor(255, 255, 255)
		love.graphics.draw(canvas, -canvas:getWidth()/2, -canvas:getHeight()/2) -- draw canvas
	end
	
	-- render planets and spaceships
	for i, entity in pairs(entities) do
		entity:draw()
	end
	
	cam:detach() -- detaching camera
	
	
	if spawning.bool then -- draw arrow
		local x, y = love.mouse.getX(), love.mouse.getY()
		local cx, cy = cam:cameraCoords(spawning.x, spawning.y)
		local x1, y1, x2, y2 = garm.arrow(math.angle(cx, cy, x, y), 32, 0.8)
		love.graphics.setLineWidth(6)
		love.graphics.setColor(0, 0, 0)
		love.graphics.circle("fill", x+x1, y+y1, 3, 10)
		love.graphics.circle("fill", x+x2, y+y2, 3, 10)
		love.graphics.circle("fill", cx, cy, 3, 10)
		love.graphics.line(cx, cy, x, y)
		love.graphics.line(x+x1, y+y1, x, y, x+x2, y+y2)
		love.graphics.setLineWidth(4)
		love.graphics.setColor(255, 0, 0)
		love.graphics.circle("fill", x+x1, y+y1, 2, 10)
		love.graphics.circle("fill", x+x2, y+y2, 2, 10)
		love.graphics.circle("fill", cx, cy, 2, 10)
		love.graphics.line(cx, cy, x, y)
		love.graphics.line(cx, cy, x, y)
		love.graphics.line(x+x1, y+y1, x, y, x+x2, y+y2)
		love.graphics.setLineWidth(1)
	end
	
	
	-- debugging text
	love.graphics.origin()
	love.graphics.setColor(0, 0, 0)
	if debugdisplay then
		local str = "Made by Garmelon"
		str = str .. "\nFPS           : " .. love.timer.getFPS()
		str = str .. "\nPo2 syndrome  : " .. tostring(not love.graphics.isSupported("npot"))
		str = str .. "\nCamera scale  : " .. cam.scale
		str = str .. "\nrectime       : " .. rectime
		str = str .. "\nPlacing       : " .. tostring(spawning.bool)
		love.graphics.print(str, 0, 0)
	end
	if helpdisplay then
		local str = ""
		str = str .. "\nEsc: Quit program"
		str = str .. "\nH  : Toggle this help"
		str = str .. "\nD  : Toggle debugging display"
		str = str .. "\nF  : Toggle trails"
		str = str .. "\nC  : Toggle whether you can control the spaceships you spawn"
		str = str .. "\nR  : Reload current scenario"
		str = str .. "\nE  : Load previous scenario"
		str = str .. "\nT  : Load next scenario"
		str = str .. "\nO and P   : Pixelate! (You have to disable trails for this to work)"
		str = str .. "\nArrow keys: control spaceship."
		str = str .. "\nClick and drag (lmb) to create new spaceships."
		str = str .. "\nClick, drag (rmb) and scroll: camera controls"
		str = str .. "\n"
		str = str .. "\ncurr. scenario: " .. currentscenario
		str = str .. "\nTrails        : " .. tostring(trails)
		str = str .. "\ncontrolled    : " .. tostring(controlled)
		love.graphics.print(str, 0, love.graphics.getFont():getHeight()*10)
	end
	
	if not trails then
		camsp:stopRecording() ----------------------------------------------------------------
		camsp:draw() ----------------------------------------------------------------
	end
end

function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
	if key == "x" then
		for _, entity in pairs(entities) do
			entity:shoot()
		end
	end
	if key == "d" then
		debugdisplay = not debugdisplay
	end
	if key == "h" then
		helpdisplay = not helpdisplay
	end
	--scenarios
	if key == "r" then
		loadScenario(currentscenario)
	end
	if key == "e" then
		currentscenario = (currentscenario - 1)%(#scenarios + 1)
		loadScenario(currentscenario)
	end
	if key == "t" then
		currentscenario = (currentscenario + 1)%(#scenarios + 1)
		loadScenario(currentscenario)
	end
	if key == "c" then
		controlled = not controlled
	end
	if key == "f" then
		trails = not trails
		if not trails then
			canvas:clear(255, 255, 255)
		end
	end
	if key == "o" then
		camspval = math.max(camspval - 1, 1)
		camsp = Pixelcam(camspval)
	end
	if key == "p" then
		camspval = math.max(camspval + 1, 1)
		camsp = Pixelcam(camspval)
	end
end

function love.mousepressed(x, y, button)
	if button == 'r' then -- start moving camera
		cam.moving = true
	elseif button == "l" then
		spawning.x, spawning.y = cam:mousepos()
		spawning.bool = true
	elseif button == "wu" then -- zoom in
		cam:zoom(1.25)
	elseif button == "wd" then -- zoom out
		cam:zoom(0.8)
	end
end

function love.mousereleased(x, y, button)
	if button == 'r' then --stop moving camera
		cam.moving = false
	elseif button == "l" and spawning.bool then -- spawn spaceplane
		spawning.bool = false
		local gx, gy = cam:mousepos()
		vx, vy = gx - spawning.x, gy - spawning.y
		local r, g, b = 0, 255, 255
		if controlled then r, g, b = 255, 127, 0 end
		table.insert(entities, Spaceship(0, controlled, spawning.x, spawning.y, vx/200, vy/200, r, g, b)) -- mass of 0 so it doesn't affect planets
	end
end

function love.mousemoved(x, y, dx, dy)
	if cam.moving then -- while LMB is pressed, move the camera
		cam:move((-dx)/cam.scale, (-dy)/cam.scale)
	end
end

function loadScenario(id)
	entities = garm.copy(scenarios[id])
	rectime = 0
	cam:lookAt(0, 0)
	cam.scale = 1
	canvas:clear(255, 255, 255)
end