Planet = Class{
	init = function(self, mass, fixed, x, y, vx, vy, r, g, b)
		self.mass = mass
		self.fixed = fixed
		self.position = {
			x = x,
			y = y,
		}
		self.lastpos = {
			x = x,
			y = y,
		}
		self.velocity = {
			x = vx,
			y = vy,
		}--[[
		self.lastvel = {
			x = vx,
			y = vy,
		}]]
		self.color = {
			r = r,
			g = g,
			b = b,
		}
	end
}

-- Ein Ansatz, den ich vielleicht weiter verfolgen werde.
-- Ist aber viel ungenauer im Vergleich zu dem aktiven.

--[[--
function Planet:calcPosition()
	if self.fixed then return end
	self.position.x = self.position.x + (self.lastvel.x + self.velocity.x)*steptime/2
	self.position.y = self.position.y + (self.lastvel.y + self.velocity.y)*steptime/2
end

function Planet:calcGravity()
	if self.fixed then return end
	self.lastvel.x = self.velocity.x
	self.lastvel.y = self.velocity.y
	for _, entity in pairs(entities) do
		if entity ~= self then
			local dist = math.dist(self.position.x, self.position.y, entity.position.x, entity.position.y)
			local ang = math.angle(self.position.x, self.position.y, entity.position.x, entity.position.y)
			local dvx = math.cos(ang)*(entity.mass/dist^2)*steptime
			local dvy = math.sin(ang)*(entity.mass/dist^2)*steptime
			self.velocity.x = self.velocity.x + dvx
			self.velocity.y = self.velocity.y + dvy
		end
	end
end
--]]--

function Planet:calcPosition()
	if self.fixed then return end
	self.position.x = self.position.x + self.velocity.x*steptime
	self.position.y = self.position.y + self.velocity.y*steptime
end

function Planet:calcGravity()
	if self.fixed then return end
	for _, entity in pairs(entities) do
		if entity ~= self then
			local dist = math.dist(self.position.x, self.position.y, entity.position.x, entity.position.y)
			local ang = math.angle(self.position.x, self.position.y, entity.position.x, entity.position.y)
			local strength = math.clamp(0, (entity.mass/dist^2)*steptime, 1) -- die eigene Masse kürzt sich raus
			local dvx = math.cos(ang)*strength
			local dvy = math.sin(ang)*strength
			self.velocity.x = self.velocity.x + dvx
			self.velocity.y = self.velocity.y + dvy
		end
	end
end

function Planet:shoot() end

function Planet:draw() -- Radius basiert auf Masse des Planeten
	-- render to canvas
	if trails then
		canvas:renderTo(function()
			love.graphics.setLineWidth(1)
			love.graphics.setColor(self.color.r, self.color.g, self.color.b)
			love.graphics.push()
			love.graphics.origin()
			love.graphics.translate(canvas:getWidth()/2, canvas:getHeight()/2)
			love.graphics.line(self.lastpos.x, self.lastpos.y, self.position.x, self.position.y)
			love.graphics.pop()
		end)
	end
	self.lastpos.x, self.lastpos.y = self.position.x, self.position.y -- outside the above loop etc. to avoid artifacts when toggling trails
	
	-- render planet
	love.graphics.setColor(self.color.r, self.color.g, self.color.b)
	love.graphics.circle("fill", self.position.x, self.position.y, math.sqrt(self.mass/math.pi)*10, planetsegments)
	love.graphics.setColor(0, 0, 0)
	love.graphics.circle("line", self.position.x, self.position.y, math.sqrt(self.mass/math.pi)*10, planetsegments)
end